#include <Servo.h>   

//Define the rotation angle of the servo motor
#define unpress_angle1 0   
#define press_angle1 80 

//Define the input port of the light intensity sensor,
//and set the judgment value. The higher the light intensity, the lower the input value. 
//If the garbage is full, the infrared rays are cut off, 
//the light intensity becomes lower, and the input value will be larger than the judgment value.
#define AD0 A0    
#define judging_intensity  120

int Intensity1= 0;
int timeON = 10;

//Define the output ports of the blue light and the green light. 
//The blue light indicates that the trash can is full and the flag is 1. 
//The green light indicates that it is not full, and the flag is 0 at this time.
const int ledPin1 = 4;//blue
const int ledPin0 = 7;//green
int flag=0;//0 means light green, 1 means light blue

Servo servo;
int servoPin = 9;//Servo motor output port is 9
int trigPin = 2;//The two port of the ultrasonic sensor are 2 and 3 respectively.    
int echoPin = 3;   
long duration, distance;   
long aver[2];//Store the distance detected by the ultrasonic sensor, and then take their average as the output   

//setup the ports of light intensity sensor, laser module, ultrasonic sensor, led
void setup() { 
   Serial.begin(9600);
  pinMode(4, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(6, OUTPUT);    
  servo.attach(servoPin);  
  pinMode(trigPin, OUTPUT);  
  pinMode(echoPin, INPUT); 
  servo.write(0); 
  delay(1000);
  servo.detach();
} 
//Measuring distance of ultrasonic sensor,
//We measure the time interval between sending and receiving ultrasonic waves. 
//This value is multiplied by the speed of sound and divided by two 
//to get the distance of the object being measured.
void measure() {  
  digitalWrite(trigPin, LOW);
  delayMicroseconds(5);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(15);
  digitalWrite(trigPin, LOW);
  pinMode(echoPin, INPUT);
  duration = pulseIn(echoPin, HIGH);
  distance = duration *0.034 / 2;
}

void loop() { 
//Turn on the laser module, 
//the laser will just shine on the light intensity sensor
  digitalWrite(6, HIGH);
  delayMicroseconds(timeON);
  delay(1); 
  
//Detect the distance twice and take the average value, 
//which can filter noise and reduce the sensitivity of 
//triggering the opening of the trash can lid.
//then output the distance.
  for (int i=0;i<=1;i++) {   
    measure();               
    aver[i]=distance;            
    delay(50);           
  }
  distance=(aver[0]+aver[1])/2; 
  Serial.print(" | | Distance = ");
  Serial.print(distance)

//If someone wants to throw garbage in front of the trash can, 
//the ultrasonic sensor will detect the person.
//If the distance is less than 40cm, 
//then driving the servo motor,
//the lid of the trash can will be opened.
  if (distance<40) {
    servo.attach(servoPin);
    delay(1);
    servo.write( unpress_angle1);  
    delay(3000);  
    servo.write(press_angle1);    
    delay(1000);
    servo.detach();      
  }
//If the flag is 0, the green light is on, the trash can is not full. 
//If it is 1, the blue light is on,the trash can is full.
    if(flag==0)
  {  
    Serial.println(flag);
   digitalWrite(ledPin0,HIGH);
  digitalWrite(ledPin1,LOW);
  delay(1000);
   Serial.println("state---------------flag=00000");
  }
   else
   { 
  Serial.println(flag);
  digitalWrite(ledPin0,LOW);
  digitalWrite(ledPin1,HIGH);
  delay(1000);
  Serial.println("state---------------flag=11111");
   }

//If the garbage is full, the infrared rays are cut off, 
//the light intensity becomes lower, 
//and the input value will be larger than the judgment value.
//At this time, we need to change the flag to 1, 
//indicating that the trash can is already full.
//On the next main loop, the trash can will light up blue.  
 Intensity1 = analogRead(AD0);
 Serial.println(String(Intensity1));
  if(Intensity1>judging_intensity)
  {
  flag=1;
 Serial.println("change flag to***********111111");
  }
  else
  {
 Serial.println("change flag to***********00000");
   flag=0; 
  }
}
